import { ExceptionBase } from '@mobicoop/ddd-library';

export class AuthenticationAlreadyExistsException extends ExceptionBase {
  static readonly message = 'Authentication already exists';

  public readonly code = 'AUTHENTICATION.ALREADY_EXISTS';

  constructor(cause?: Error, metadata?: unknown) {
    super(AuthenticationAlreadyExistsException.message, cause, metadata);
  }
}

export class UsernameAlreadyExistsException extends ExceptionBase {
  static readonly message = 'Username already exists';

  public readonly code = 'USERNAME.ALREADY_EXISTS';

  constructor(cause?: Error, metadata?: unknown) {
    super(UsernameAlreadyExistsException.message, cause, metadata);
  }
}
